<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `/nix/store/kaan79bbbx80h17lcc5ay919l5r6bqlz-vendored-sources/regex-1.6.0/src/backtrack.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>backtrack.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../regex/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../regex/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../regex/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
<span id="43">43</span>
<span id="44">44</span>
<span id="45">45</span>
<span id="46">46</span>
<span id="47">47</span>
<span id="48">48</span>
<span id="49">49</span>
<span id="50">50</span>
<span id="51">51</span>
<span id="52">52</span>
<span id="53">53</span>
<span id="54">54</span>
<span id="55">55</span>
<span id="56">56</span>
<span id="57">57</span>
<span id="58">58</span>
<span id="59">59</span>
<span id="60">60</span>
<span id="61">61</span>
<span id="62">62</span>
<span id="63">63</span>
<span id="64">64</span>
<span id="65">65</span>
<span id="66">66</span>
<span id="67">67</span>
<span id="68">68</span>
<span id="69">69</span>
<span id="70">70</span>
<span id="71">71</span>
<span id="72">72</span>
<span id="73">73</span>
<span id="74">74</span>
<span id="75">75</span>
<span id="76">76</span>
<span id="77">77</span>
<span id="78">78</span>
<span id="79">79</span>
<span id="80">80</span>
<span id="81">81</span>
<span id="82">82</span>
<span id="83">83</span>
<span id="84">84</span>
<span id="85">85</span>
<span id="86">86</span>
<span id="87">87</span>
<span id="88">88</span>
<span id="89">89</span>
<span id="90">90</span>
<span id="91">91</span>
<span id="92">92</span>
<span id="93">93</span>
<span id="94">94</span>
<span id="95">95</span>
<span id="96">96</span>
<span id="97">97</span>
<span id="98">98</span>
<span id="99">99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
</pre><pre class="rust"><code><span class="comment">// This is the backtracking matching engine. It has the same exact capability</span>
<span class="comment">// as the full NFA simulation, except it is artificially restricted to small</span>
<span class="comment">// regexes on small inputs because of its memory requirements.</span>
<span class="comment">//</span>
<span class="comment">// In particular, this is a *bounded* backtracking engine. It retains worst</span>
<span class="comment">// case linear time by keeping track of the states that it has visited (using a</span>
<span class="comment">// bitmap). Namely, once a state is visited, it is never visited again. Since a</span>
<span class="comment">// state is keyed by `(instruction index, input index)`, we have that its time</span>
<span class="comment">// complexity is `O(mn)` (i.e., linear in the size of the search text).</span>
<span class="comment">//</span>
<span class="comment">// The backtracking engine can beat out the NFA simulation on small</span>
<span class="comment">// regexes/inputs because it doesn&#39;t have to keep track of multiple copies of</span>
<span class="comment">// the capture groups. In benchmarks, the backtracking engine is roughly twice</span>
<span class="comment">// as fast as the full NFA simulation. Note though that its performance doesn&#39;t</span>
<span class="comment">// scale, even if you&#39;re willing to live with the memory requirements. Namely,</span>
<span class="comment">// the bitset has to be zeroed on each execution, which becomes quite expensive</span>
<span class="comment">// on large bitsets.</span>

<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::exec::ProgramCache</span>;
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::input</span>::{<span class="ident">Input</span>, <span class="ident">InputAt</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::prog</span>::{<span class="ident">InstPtr</span>, <span class="ident">Program</span>};
<span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::re_trait::Slot</span>;

<span class="kw">type</span> <span class="ident">Bits</span> <span class="op">=</span> <span class="ident">u32</span>;

<span class="kw">const</span> <span class="ident">BIT_SIZE</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">32</span>;
<span class="kw">const</span> <span class="ident">MAX_SIZE_BYTES</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">256</span> <span class="op">*</span> (<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">10</span>); <span class="comment">// 256 KB</span>

<span class="doccomment">/// Returns true iff the given regex and input should be executed by this</span>
<span class="doccomment">/// engine with reasonable memory usage.</span>
<span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">should_exec</span>(<span class="ident">num_insts</span>: <span class="ident">usize</span>, <span class="ident">text_len</span>: <span class="ident">usize</span>) -&gt; <span class="ident">bool</span> {
    <span class="comment">// Total memory usage in bytes is determined by:</span>
    <span class="comment">//</span>
    <span class="comment">//   ((len(insts) * (len(input) + 1) + bits - 1) / bits) * (size_of(u32))</span>
    <span class="comment">//</span>
    <span class="comment">// The actual limit picked is pretty much a heuristic.</span>
    <span class="comment">// See: https://github.com/rust-lang/regex/issues/215</span>
    <span class="kw">let</span> <span class="ident">size</span> <span class="op">=</span> ((<span class="ident">num_insts</span> <span class="op">*</span> (<span class="ident">text_len</span> <span class="op">+</span> <span class="number">1</span>) <span class="op">+</span> <span class="ident">BIT_SIZE</span> <span class="op">-</span> <span class="number">1</span>) <span class="op">/</span> <span class="ident">BIT_SIZE</span>) <span class="op">*</span> <span class="number">4</span>;
    <span class="ident">size</span> <span class="op">&lt;</span><span class="op">=</span> <span class="ident">MAX_SIZE_BYTES</span>
}

<span class="doccomment">/// A backtracking matching engine.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Bounded</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;m</span>, <span class="lifetime">&#39;r</span>, <span class="lifetime">&#39;s</span>, <span class="ident">I</span><span class="op">&gt;</span> {
    <span class="ident">prog</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;r</span> <span class="ident">Program</span>,
    <span class="ident">input</span>: <span class="ident">I</span>,
    <span class="ident">matches</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;m</span> <span class="kw-2">mut</span> [<span class="ident">bool</span>],
    <span class="ident">slots</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;s</span> <span class="kw-2">mut</span> [<span class="ident">Slot</span>],
    <span class="ident">m</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;a</span> <span class="kw-2">mut</span> <span class="ident">Cache</span>,
}

<span class="doccomment">/// Shared cached state between multiple invocations of a backtracking engine</span>
<span class="doccomment">/// in the same thread.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Cache</span> {
    <span class="ident">jobs</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Job</span><span class="op">&gt;</span>,
    <span class="ident">visited</span>: <span class="ident">Vec</span><span class="op">&lt;</span><span class="ident">Bits</span><span class="op">&gt;</span>,
}

<span class="kw">impl</span> <span class="ident">Cache</span> {
    <span class="doccomment">/// Create new empty cache for the backtracking engine.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>(<span class="ident">_prog</span>: <span class="kw-2">&amp;</span><span class="ident">Program</span>) -&gt; <span class="self">Self</span> {
        <span class="ident">Cache</span> { <span class="ident">jobs</span>: <span class="macro">vec!</span>[], <span class="ident">visited</span>: <span class="macro">vec!</span>[] }
    }
}

<span class="doccomment">/// A job is an explicit unit of stack space in the backtracking engine.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// The &quot;normal&quot; representation is a single state transition, which corresponds</span>
<span class="doccomment">/// to an NFA state and a character in the input. However, the backtracking</span>
<span class="doccomment">/// engine must keep track of old capture group values. We use the explicit</span>
<span class="doccomment">/// stack to do it.</span>
<span class="attribute">#[<span class="ident">derive</span>(<span class="ident">Clone</span>, <span class="ident">Copy</span>, <span class="ident">Debug</span>)]</span>
<span class="kw">enum</span> <span class="ident">Job</span> {
    <span class="ident">Inst</span> { <span class="ident">ip</span>: <span class="ident">InstPtr</span>, <span class="ident">at</span>: <span class="ident">InputAt</span> },
    <span class="ident">SaveRestore</span> { <span class="ident">slot</span>: <span class="ident">usize</span>, <span class="ident">old_pos</span>: <span class="prelude-ty">Option</span><span class="op">&lt;</span><span class="ident">usize</span><span class="op">&gt;</span> },
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;m</span>, <span class="lifetime">&#39;r</span>, <span class="lifetime">&#39;s</span>, <span class="ident">I</span>: <span class="ident">Input</span><span class="op">&gt;</span> <span class="ident">Bounded</span><span class="op">&lt;</span><span class="lifetime">&#39;a</span>, <span class="lifetime">&#39;m</span>, <span class="lifetime">&#39;r</span>, <span class="lifetime">&#39;s</span>, <span class="ident">I</span><span class="op">&gt;</span> {
    <span class="doccomment">/// Execute the backtracking matching engine.</span>
    <span class="doccomment">///</span>
    <span class="doccomment">/// If there&#39;s a match, `exec` returns `true` and populates the given</span>
    <span class="doccomment">/// captures accordingly.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">exec</span>(
        <span class="ident">prog</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;r</span> <span class="ident">Program</span>,
        <span class="ident">cache</span>: <span class="kw-2">&amp;</span><span class="ident">ProgramCache</span>,
        <span class="ident">matches</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;m</span> <span class="kw-2">mut</span> [<span class="ident">bool</span>],
        <span class="ident">slots</span>: <span class="kw-2">&amp;</span><span class="lifetime">&#39;s</span> <span class="kw-2">mut</span> [<span class="ident">Slot</span>],
        <span class="ident">input</span>: <span class="ident">I</span>,
        <span class="ident">start</span>: <span class="ident">usize</span>,
        <span class="ident">end</span>: <span class="ident">usize</span>,
    ) -&gt; <span class="ident">bool</span> {
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">cache</span> <span class="op">=</span> <span class="ident">cache</span>.<span class="ident">borrow_mut</span>();
        <span class="kw">let</span> <span class="ident">cache</span> <span class="op">=</span> <span class="kw-2">&amp;mut</span> <span class="ident">cache</span>.<span class="ident">backtrack</span>;
        <span class="kw">let</span> <span class="ident">start</span> <span class="op">=</span> <span class="ident">input</span>.<span class="ident">at</span>(<span class="ident">start</span>);
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">b</span> <span class="op">=</span> <span class="ident">Bounded</span> { <span class="ident">prog</span>, <span class="ident">input</span>, <span class="ident">matches</span>, <span class="ident">slots</span>, <span class="ident">m</span>: <span class="ident">cache</span> };
        <span class="ident">b</span>.<span class="ident">exec_</span>(<span class="ident">start</span>, <span class="ident">end</span>)
    }

    <span class="doccomment">/// Clears the cache such that the backtracking engine can be executed</span>
    <span class="doccomment">/// on some input of fixed length.</span>
    <span class="kw">fn</span> <span class="ident">clear</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="comment">// Reset the job memory so that we start fresh.</span>
        <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">jobs</span>.<span class="ident">clear</span>();

        <span class="comment">// Now we need to clear the bit state set.</span>
        <span class="comment">// We do this by figuring out how much space we need to keep track</span>
        <span class="comment">// of the states we&#39;ve visited.</span>
        <span class="comment">// Then we reset all existing allocated space to 0.</span>
        <span class="comment">// Finally, we request more space if we need it.</span>
        <span class="comment">//</span>
        <span class="comment">// This is all a little circuitous, but doing this using unchecked</span>
        <span class="comment">// operations doesn&#39;t seem to have a measurable impact on performance.</span>
        <span class="comment">// (Probably because backtracking is limited to such small</span>
        <span class="comment">// inputs/regexes in the first place.)</span>
        <span class="kw">let</span> <span class="ident">visited_len</span> <span class="op">=</span>
            (<span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">len</span>() <span class="op">*</span> (<span class="self">self</span>.<span class="ident">input</span>.<span class="ident">len</span>() <span class="op">+</span> <span class="number">1</span>) <span class="op">+</span> <span class="ident">BIT_SIZE</span> <span class="op">-</span> <span class="number">1</span>)
                <span class="op">/</span> <span class="ident">BIT_SIZE</span>;
        <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span>.<span class="ident">truncate</span>(<span class="ident">visited_len</span>);
        <span class="kw">for</span> <span class="ident">v</span> <span class="kw">in</span> <span class="kw-2">&amp;mut</span> <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span> {
            <span class="kw-2">*</span><span class="ident">v</span> <span class="op">=</span> <span class="number">0</span>;
        }
        <span class="kw">if</span> <span class="ident">visited_len</span> <span class="op">&gt;</span> <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span>.<span class="ident">len</span>() {
            <span class="kw">let</span> <span class="ident">len</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span>.<span class="ident">len</span>();
            <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span>.<span class="ident">reserve_exact</span>(<span class="ident">visited_len</span> <span class="op">-</span> <span class="ident">len</span>);
            <span class="kw">for</span> <span class="kw">_</span> <span class="kw">in</span> <span class="number">0</span>..(<span class="ident">visited_len</span> <span class="op">-</span> <span class="ident">len</span>) {
                <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span>.<span class="ident">push</span>(<span class="number">0</span>);
            }
        }
    }

    <span class="doccomment">/// Start backtracking at the given position in the input, but also look</span>
    <span class="doccomment">/// for literal prefixes.</span>
    <span class="kw">fn</span> <span class="ident">exec_</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="kw-2">mut</span> <span class="ident">at</span>: <span class="ident">InputAt</span>, <span class="ident">end</span>: <span class="ident">usize</span>) -&gt; <span class="ident">bool</span> {
        <span class="self">self</span>.<span class="ident">clear</span>();
        <span class="comment">// If this is an anchored regex at the beginning of the input, then</span>
        <span class="comment">// we&#39;re either already done or we only need to try backtracking once.</span>
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">is_anchored_start</span> {
            <span class="kw">return</span> <span class="kw">if</span> <span class="op">!</span><span class="ident">at</span>.<span class="ident">is_start</span>() { <span class="bool-val">false</span> } <span class="kw">else</span> { <span class="self">self</span>.<span class="ident">backtrack</span>(<span class="ident">at</span>) };
        }
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">matched</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="kw">loop</span> {
            <span class="kw">if</span> <span class="op">!</span><span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">prefixes</span>.<span class="ident">is_empty</span>() {
                <span class="ident">at</span> <span class="op">=</span> <span class="kw">match</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">prefix_at</span>(<span class="kw-2">&amp;</span><span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">prefixes</span>, <span class="ident">at</span>) {
                    <span class="prelude-val">None</span> =&gt; <span class="kw">break</span>,
                    <span class="prelude-val">Some</span>(<span class="ident">at</span>) =&gt; <span class="ident">at</span>,
                };
            }
            <span class="ident">matched</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">backtrack</span>(<span class="ident">at</span>) <span class="op">|</span><span class="op">|</span> <span class="ident">matched</span>;
            <span class="kw">if</span> <span class="ident">matched</span> <span class="op">&amp;&amp;</span> <span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">matches</span>.<span class="ident">len</span>() <span class="op">==</span> <span class="number">1</span> {
                <span class="kw">return</span> <span class="bool-val">true</span>;
            }
            <span class="kw">if</span> <span class="ident">at</span>.<span class="ident">pos</span>() <span class="op">&gt;</span><span class="op">=</span> <span class="ident">end</span> {
                <span class="kw">break</span>;
            }
            <span class="ident">at</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">at</span>(<span class="ident">at</span>.<span class="ident">next_pos</span>());
        }
        <span class="ident">matched</span>
    }

    <span class="doccomment">/// The main backtracking loop starting at the given input position.</span>
    <span class="kw">fn</span> <span class="ident">backtrack</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">start</span>: <span class="ident">InputAt</span>) -&gt; <span class="ident">bool</span> {
        <span class="comment">// N.B. We use an explicit stack to avoid recursion.</span>
        <span class="comment">// To avoid excessive pushing and popping, most transitions are handled</span>
        <span class="comment">// in the `step` helper function, which only pushes to the stack when</span>
        <span class="comment">// there&#39;s a capture or a branch.</span>
        <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">matched</span> <span class="op">=</span> <span class="bool-val">false</span>;
        <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">jobs</span>.<span class="ident">push</span>(<span class="ident">Job::Inst</span> { <span class="ident">ip</span>: <span class="number">0</span>, <span class="ident">at</span>: <span class="ident">start</span> });
        <span class="kw">while</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">job</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">jobs</span>.<span class="ident">pop</span>() {
            <span class="kw">match</span> <span class="ident">job</span> {
                <span class="ident">Job::Inst</span> { <span class="ident">ip</span>, <span class="ident">at</span> } =&gt; {
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">step</span>(<span class="ident">ip</span>, <span class="ident">at</span>) {
                        <span class="comment">// Only quit if we&#39;re matching one regex.</span>
                        <span class="comment">// If we&#39;re matching a regex set, then mush on and</span>
                        <span class="comment">// try to find other matches (if we want them).</span>
                        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">prog</span>.<span class="ident">matches</span>.<span class="ident">len</span>() <span class="op">==</span> <span class="number">1</span> {
                            <span class="kw">return</span> <span class="bool-val">true</span>;
                        }
                        <span class="ident">matched</span> <span class="op">=</span> <span class="bool-val">true</span>;
                    }
                }
                <span class="ident">Job::SaveRestore</span> { <span class="ident">slot</span>, <span class="ident">old_pos</span> } =&gt; {
                    <span class="kw">if</span> <span class="ident">slot</span> <span class="op">&lt;</span> <span class="self">self</span>.<span class="ident">slots</span>.<span class="ident">len</span>() {
                        <span class="self">self</span>.<span class="ident">slots</span>[<span class="ident">slot</span>] <span class="op">=</span> <span class="ident">old_pos</span>;
                    }
                }
            }
        }
        <span class="ident">matched</span>
    }

    <span class="kw">fn</span> <span class="ident">step</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="kw-2">mut</span> <span class="ident">ip</span>: <span class="ident">InstPtr</span>, <span class="kw-2">mut</span> <span class="ident">at</span>: <span class="ident">InputAt</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw">use</span> <span class="ident"><span class="kw">crate</span>::prog::Inst</span>::<span class="kw-2">*</span>;
        <span class="kw">loop</span> {
            <span class="comment">// This loop is an optimization to avoid constantly pushing/popping</span>
            <span class="comment">// from the stack. Namely, if we&#39;re pushing a job only to run it</span>
            <span class="comment">// next, avoid the push and just mutate `ip` (and possibly `at`)</span>
            <span class="comment">// in place.</span>
            <span class="kw">if</span> <span class="self">self</span>.<span class="ident">has_visited</span>(<span class="ident">ip</span>, <span class="ident">at</span>) {
                <span class="kw">return</span> <span class="bool-val">false</span>;
            }
            <span class="kw">match</span> <span class="self">self</span>.<span class="ident">prog</span>[<span class="ident">ip</span>] {
                <span class="ident">Match</span>(<span class="ident">slot</span>) =&gt; {
                    <span class="kw">if</span> <span class="ident">slot</span> <span class="op">&lt;</span> <span class="self">self</span>.<span class="ident">matches</span>.<span class="ident">len</span>() {
                        <span class="self">self</span>.<span class="ident">matches</span>[<span class="ident">slot</span>] <span class="op">=</span> <span class="bool-val">true</span>;
                    }
                    <span class="kw">return</span> <span class="bool-val">true</span>;
                }
                <span class="ident">Save</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="kw-2">&amp;</span><span class="ident">old_pos</span>) <span class="op">=</span> <span class="self">self</span>.<span class="ident">slots</span>.<span class="ident">get</span>(<span class="ident">inst</span>.<span class="ident">slot</span>) {
                        <span class="comment">// If this path doesn&#39;t work out, then we save the old</span>
                        <span class="comment">// capture index (if one exists) in an alternate</span>
                        <span class="comment">// job. If the next path fails, then the alternate</span>
                        <span class="comment">// job is popped and the old capture index is restored.</span>
                        <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">jobs</span>.<span class="ident">push</span>(<span class="ident">Job::SaveRestore</span> {
                            <span class="ident">slot</span>: <span class="ident">inst</span>.<span class="ident">slot</span>,
                            <span class="ident">old_pos</span>,
                        });
                        <span class="self">self</span>.<span class="ident">slots</span>[<span class="ident">inst</span>.<span class="ident">slot</span>] <span class="op">=</span> <span class="prelude-val">Some</span>(<span class="ident">at</span>.<span class="ident">pos</span>());
                    }
                    <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto</span>;
                }
                <span class="ident">Split</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">jobs</span>.<span class="ident">push</span>(<span class="ident">Job::Inst</span> { <span class="ident">ip</span>: <span class="ident">inst</span>.<span class="ident">goto2</span>, <span class="ident">at</span> });
                    <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto1</span>;
                }
                <span class="ident">EmptyLook</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="kw">if</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">is_empty_match</span>(<span class="ident">at</span>, <span class="ident">inst</span>) {
                        <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto</span>;
                    } <span class="kw">else</span> {
                        <span class="kw">return</span> <span class="bool-val">false</span>;
                    }
                }
                <span class="ident">Char</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="kw">if</span> <span class="ident">inst</span>.<span class="ident">c</span> <span class="op">==</span> <span class="ident">at</span>.<span class="ident">char</span>() {
                        <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto</span>;
                        <span class="ident">at</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">at</span>(<span class="ident">at</span>.<span class="ident">next_pos</span>());
                    } <span class="kw">else</span> {
                        <span class="kw">return</span> <span class="bool-val">false</span>;
                    }
                }
                <span class="ident">Ranges</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="kw">if</span> <span class="ident">inst</span>.<span class="ident">matches</span>(<span class="ident">at</span>.<span class="ident">char</span>()) {
                        <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto</span>;
                        <span class="ident">at</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">at</span>(<span class="ident">at</span>.<span class="ident">next_pos</span>());
                    } <span class="kw">else</span> {
                        <span class="kw">return</span> <span class="bool-val">false</span>;
                    }
                }
                <span class="ident">Bytes</span>(<span class="kw-2">ref</span> <span class="ident">inst</span>) =&gt; {
                    <span class="kw">if</span> <span class="kw">let</span> <span class="prelude-val">Some</span>(<span class="ident">b</span>) <span class="op">=</span> <span class="ident">at</span>.<span class="ident">byte</span>() {
                        <span class="kw">if</span> <span class="ident">inst</span>.<span class="ident">matches</span>(<span class="ident">b</span>) {
                            <span class="ident">ip</span> <span class="op">=</span> <span class="ident">inst</span>.<span class="ident">goto</span>;
                            <span class="ident">at</span> <span class="op">=</span> <span class="self">self</span>.<span class="ident">input</span>.<span class="ident">at</span>(<span class="ident">at</span>.<span class="ident">next_pos</span>());
                            <span class="kw">continue</span>;
                        }
                    }
                    <span class="kw">return</span> <span class="bool-val">false</span>;
                }
            }
        }
    }

    <span class="kw">fn</span> <span class="ident">has_visited</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>, <span class="ident">ip</span>: <span class="ident">InstPtr</span>, <span class="ident">at</span>: <span class="ident">InputAt</span>) -&gt; <span class="ident">bool</span> {
        <span class="kw">let</span> <span class="ident">k</span> <span class="op">=</span> <span class="ident">ip</span> <span class="op">*</span> (<span class="self">self</span>.<span class="ident">input</span>.<span class="ident">len</span>() <span class="op">+</span> <span class="number">1</span>) <span class="op">+</span> <span class="ident">at</span>.<span class="ident">pos</span>();
        <span class="kw">let</span> <span class="ident">k1</span> <span class="op">=</span> <span class="ident">k</span> <span class="op">/</span> <span class="ident">BIT_SIZE</span>;
        <span class="kw">let</span> <span class="ident">k2</span> <span class="op">=</span> <span class="ident">usize_to_u32</span>(<span class="number">1</span> <span class="op">&lt;</span><span class="op">&lt;</span> (<span class="ident">k</span> <span class="op">&amp;</span> (<span class="ident">BIT_SIZE</span> <span class="op">-</span> <span class="number">1</span>)));
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span>[<span class="ident">k1</span>] <span class="op">&amp;</span> <span class="ident">k2</span> <span class="op">==</span> <span class="number">0</span> {
            <span class="self">self</span>.<span class="ident">m</span>.<span class="ident">visited</span>[<span class="ident">k1</span>] <span class="op">|</span><span class="op">=</span> <span class="ident">k2</span>;
            <span class="bool-val">false</span>
        } <span class="kw">else</span> {
            <span class="bool-val">true</span>
        }
    }
}

<span class="kw">fn</span> <span class="ident">usize_to_u32</span>(<span class="ident">n</span>: <span class="ident">usize</span>) -&gt; <span class="ident">u32</span> {
    <span class="kw">if</span> (<span class="ident">n</span> <span class="kw">as</span> <span class="ident">u64</span>) <span class="op">&gt;</span> (<span class="ident">::std::u32::MAX</span> <span class="kw">as</span> <span class="ident">u64</span>) {
        <span class="macro">panic!</span>(<span class="string">&quot;BUG: {} is too big to fit into u32&quot;</span>, <span class="ident">n</span>)
    }
    <span class="ident">n</span> <span class="kw">as</span> <span class="ident">u32</span>
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="regex" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>